
module.exports = {
  'AED': {
    symbols: {
      local: 'د.إ.‏',
      global: 'Dhs',
      reverseGlobal: 'Dhs'
    },
    text: {
      ar: {
        local: {
          zero: 'درهم',
          one: 'درهم',
          two: 'درهم',
          few: 'درهم',
          many: 'درهم',
          other: 'درهم'
        }
      }
    }
  },
  'ALL': {
    symbols: {
      local: 'Lek',
      global: 'Lek',
      reverseGlobal: 'Lek'
    },
    text: {
      sq: {
        local: {
          one: 'lek',
          other: 'lekë'
        }
      }
    }
  },
  'AUD': {
    symbols: {
      local: '$',
      global: 'AU$',
      reverseGlobal: '$AU'
    },
    text: {
      en: {
        local: {
          one: 'dollar',
          other: 'dollars'
        }
      }
    }
  },
  'BDT': {
    symbols: {
      local: '৳',
      global: 'Tk',
      reverseGlobal: 'Tk'
    },
    text: {
      bn: {
        local: {
          one: 'টাকা',
          other: 'টাকা'
        }
      }
    }
  },
  'BGN': {
    symbols: {
      local: 'лв',
      global: 'lev',
      reverseGlobal: 'lev'
    },
    text: {
      bg: {
        local: {
          one: 'лев',
          other: 'лева'
        }
      }
    }
  },
  'BRL': {
    symbols: {
      locale: 'R$',
      global: 'R$',
      reverseGlobal: '$R'
    },
    text: {
      es: {
        local: {
          one: 'real',
          other: 'reales'
        }
      }
    }
  },
  'CAD': {
    symbols: {
      local: '$',
      global: 'C$',
      reverseGlobal: '$C'
    },
    text: {
      en: {
        local: {
          one: 'dollar',
          other: 'dollars'
        }
      },
      fr: {
        local: {
          one: 'dollar',
          other: 'dollars'
        }
      }
    }
  },
  'CDF': {
    symbols: {
      local: 'FC',
      global: 'FC',
      reverseGlobal: 'FC'
    },
    text: {
      fr: {
        local: {
          one: 'franc',
          other: 'francs'
        }
      }
    }
  },
  'CHF': {
    symbols: {
      local: 'CHF',
      global: 'CHF',
      reverseGlobal: 'CHF'
    },
    text: {
      it: {
        local: {
          one: 'franco',
          other: 'franchi'
        }
      },
      de: {
        local: {
          one: 'Franken',
          other: 'Franken'
        }
      },
      fr: {
        local: {
          one: 'franc',
          other: 'francs'
        }
      }
    }
  },
  'CLP': {
    symbols: {
      local: '$',
      global: 'CL$',
      reverseGlobal: '$CL'
    },
    text: {
      es: {
        local: {
          one: 'peso',
          other: 'pesos'
        }
      }
    }
  },
  'CNY': {
    symbols: {
      local: '¥',
      global: 'CN¥',
      reverseGlobal: '¥CN'
    },
    text: {
      zh: {
        local: {
          other: '元'
        }
      }
    }
  },
  'COP': {
    symbols: {
      local: '$',
      global: 'COL$',
      reverseGlobal: '$COL'
    },
    text: {
      es: {
        local: {
          one: 'peso',
          other: 'pesos'
        }
      }
    }
  },
  'CRC': {
    symbols: {
      local: '₡',
      global: 'CR₡',
      reverseGlobal: '₡CR'
    },
    text: {
      es: {
        local: {
          one: 'colón',
          other: 'colones'
        }
      }
    }
  },
  'CZK': {
    symbols: {
      local: 'Kč',
      global: 'Kč',
      reverseGlobal: 'Kč'
    },
    text: {
      local: {
        one: 'koruna',
        few: 'koruny',
        many: 'koruny',
        other: 'korun'
      }
    }
  },
  'DKK': {
    symbols: {
      local: 'kr',
      global: 'Dkr'
    },
    text: {
      da: {
        local: {
          one: 'krone',
          other: 'kroner'
        }
      }
    }
  },
  'DOP': {
    symbols: {
      local: '$',
      global: 'RD$',
      reverseGlobal: '$RD'
    },
    text: {
      es: {
        local: {
          one: 'peso',
          other: 'pesos'
        }
      }
    }
  },
  'EGP': {
    symbols: {
      local: '£',
      global: 'LE',
      reverseGlobal: 'LE'
    },
    text: {
      ar: {
        local: {
          zero: 'جنيه',
          one: 'جنيه',
          two: 'جنيه',
          few: 'جنيه',
          many: 'جنيه',
          other: 'جنيه'
        }
      }
    }
  },
  'ETB': {
    symbols: {
      local: 'ብር',
      global: 'Birr',
      reverseGlobal: 'Birr'
    },
    text: {
      am: {
        local: {
          one: 'ብር',
          other: 'ብር'
        }
      }
    }
  },
  'EUR': {
    symbols: {
      local: '€',
      global: '€',
      reverseGlobal: '€'
    },
    text: {}
  },
  'GBP': {
    symbols: {
      local: '£',
      global: 'GB£',
      reverseGlobal: '£GB'
    },
    text: {
      local: null
    }
  },
  'HKD': {
    symbols: {
      local: '$',
      global: 'HK$',
      reverseGlobal: '$HK'
    },
    text: {
      zh: {
        local: {
          other: '元'
        }
      }
    }
  },
  'HRK': {
    symbols: {
      local: 'kn',
      global: 'kn'
    },
    text: {
      hr: {
        local: {
          one: 'kuna',
          few: 'kune',
          other: 'kuna'
        }
      }
    }
  },
  'HUF': {
    symbols: {
      local: 'Ft',
      global: 'Ft'
    },
    text: {
      hu: {
        local: {
          one: 'forint',
          other: 'forint'
        }
      }
    }
  },
  'IDR': {
    symbols: {
      local: 'Rp',
      global: 'Rp'
    },
    text: {
      id: {
        local: {
          other: 'Rupiah'
        }
      },
      ms: {
        local: {
          other: 'Rupiah'
        }
      }
    }
  },
  'ILS': {
    symbols: {
      local: '₪',
      global: 'IL₪',
      reverseGlobal: '₪IL'
    },
    text: {
      he: {
        local: {
          one: 'חדשים',
          two: 'חדשים',
          many: 'חדשים',
          other: 'חדשים'
        }
      },
      ar: {
        local: {
          zero: 'شيكل',
          one: 'شيكل',
          two: 'شيكل',
          few: 'شيكل',
          many: 'شيكل',
          other: 'شيكل'
        }
      }
    }
  },
  'INR': {
    symbols: {
      local: '₹',
      global: 'Rs',
      reverseGlobal: 'Rs'
    },
    text: {
      en: {
        local: {
          one: 'rupee',
          other: 'rupees'
        }
      },
      hi: {
        local: {
          one: 'रुपया',
          other: 'रूपए'
        }
      }
    }
  },
  'IRR': {
    symbols: {
      local: 'Rial',
      global: 'IRR',
      reverseGlobal: 'IRR'
    },
    text: {
      fa: {
        local: {
          one: 'ریال',
          other: 'ریال'
        }
      }
    }
  },
  'ISK': {
    symbols: {
      local: 'kr',
      global: 'Íkr',
      reverseGlobal: 'Íkr'
    },
    text: {
      is: {
        local: {
          one: 'kóróna',
          other: 'krónur'
        }
      }
    }
  },
  'JMD': {
    symbols: {
      local: '$',
      global: 'JA$',
      reverseGlobal: '$JA'
    },
    text: {
      en: {
        local: {
          one: 'dollar',
          other: 'dollars'
        }
      }
    }
  },
  'JPY': {
    symbols: {
      local: '¥',
      global: 'JP¥',
      reverseGlobal: '¥JP'
    },
    text: {
      ja: {
        local: {
          other: '円'
        }
      }
    }
  },
  'KRW': {
    symbols: {
      local: '₩',
      global: 'KR₩'
    },
    text: {
      ko: {
        local: {
          other: '원'
        }
      }
    }
  },
  'LKR': {
    symbols: {
      local: 'Rs',
      global: 'SLRs',
      reverseGlobal: 'SLRs'
    },
    text: {
      ta: {
        local: {
          one: 'ரூபாய்',
          other: 'ரூபாய்'
        }
      },
      si: {
        local: {
          one: 'රුපියල',
          other: 'රුපියල'
        }
      }
    }
  },
  'LTL': {
    symbols: {
      local: 'Lt',
      global: 'Lt',
      reverseGlobal: 'Lt'
    },
    text: {
      lt: {
        local: {
          one: 'litas',
          few: 'litai',
          many: 'lito',
          other: 'litų'
        }
      }
    }
  },
  'LVL': {
    symbols: {
      local: 'Ls',
      global: 'Ls',
      reverseGlobal: 'Ls'
    },
    text: {
      lv: {
        local: {
          zero: 'lati',
          one: 'lats',
          other: 'lati'
        }
      }
    }
  },
  'MNT': {
    symbols: {
      local: '₮',
      global: 'MN₮',
      reverseGlobal: '₮MN'
    },
    text: {
      local: {
        one: 'төгрөг',
        other: 'төгрөг'
      }
    }
  },
  'MXN': {
    symbols: {
      local: '$',
      global: 'MX$',
      reverseGlobal: '$MX'
    },
    text: {
      es: {
        local: {
          one: 'peso',
          other: 'pesos'
        }
      }
    }
  },
  'MYR': {
    symbols: {
      local: 'RM',
      global: 'RM',
      reverseGlobal: 'RM'
    },
    text: {
      ms: {
        local: {
          other: 'Ringgit'
        }
      }
    }
  },
  'NOK': {
    symbols: {
      local: 'kr',
      global: 'Nkr',
      reverseGlobal: 'Nkr'
    },
    text: {
      no: {
        local: {
          one: 'krone',
          other: 'kroner'
        }
      }
    }
  },
  'PAB': {
    symbols: {
      local: 'B/.',
      global: 'B/.',
      reverseGlobal: 'B/.'
    },
    text: {
      es: {
        local: {
          one: 'balboa',
          other: 'balboas'
        }
      }
    }
  },
  'PEN': {
    symbols: {
      local: 'S/.',
      global: 'S/.',
      reverseGlobal: 'S/.'
    },
    text: {
      es: {
        local: {
          one: 'peruano',
          other: 'peruanos'
        }
      }
    }
  },
  'PHP': {
    symbols: {
      local: '₱',
      global: 'Php',
      reverseGlobal: 'Php'
    },
    text: {
      en: {
        local: {
          one: 'peso',
          other: 'pesos'
        }
      },
      fil: {
        local: {
          one: 'peso',
          other: 'pesos'
        }
      }
    }
  },
  'PKR': {
    symbols: {
      local: 'Rs',
      global: 'PKRs.',
      reverseGlobal: 'PKRs.'
    },
    text: {
      en: {
        local: {
          one: 'rupee',
          other: 'rupees'
        }
      },
      ur: {
        local: {
          one: 'روپیہ',
          other: 'روپیہ'
        }
      }
    }
  },
  'PLN': {
    symbols: {
      local: 'zł',
      global: 'zł',
      reverseGlobal: 'łz'
    },
    text: {
      pl: {
        local: {
          one: 'złoty',
          few: 'złote',
          many: 'złotych',
          other: 'złotego'
        }
      }
    }
  },
  'RON': {
    symbols: {
      local: 'lei',
      global: 'lei',
      reverseGlobal: 'lei'
    },
    text: {
      ro: {
        local: {
          one: 'leu',
          few: 'lei',
          other: 'lei'
        }
      }
    }
  },
  'RSD': {
    symbols: {
      local: 'дин.',
      global: 'РСД'
    },
    text: {
      sr: {
        local: {
          one: 'динар',
          few: 'динара',
          other: 'динара'
        }
      }
    }
  },
  'RUB': {
    symbols: {
      local: '₽',
      global: '₽',
      reverseGlobal: '₽'
    },
    text: {
      ru: {
        local: {
          one: 'рубль',
          many: 'рублей',
          other: 'рубля'
        }
      }
    }
  },
  'SAR': {
    symbols: {
      local: 'Rial',
      global: 'Rial'
    },
    text: {
      ar: {
        local: {
          zero: 'ريال',
          one: 'ريال',
          two: 'ريال',
          few: 'ريال',
          many: 'ريال',
          other: 'ريال'
        }
      }
    }
  },
  'SEK': {
    symbols: {
      local: 'kr',
      global: 'Skr'
    },
    text: {
      sv: {
        local: {
          one: 'krona',
          other: 'kronor'
        }
      }
    }
  },
  'SGD': {
    symbols: {
      local: '$',
      global: 'S$',
      reverseGlobal: '$S'
    },
    text: {
      en: {
        local: {
          one: 'dollar',
          other: 'dollars'
        }
      },
      ms: {
        local: {
          other: 'Dolar'
        }
      },
      ta: {
        local: {
          one: 'டாலர்',
          other: 'டாலர்'
        }
      },
      zh: {
        local: {
          other: '元'
        }
      }
    }
  },
  'THB': {
    symbols: {
      local: '฿',
      global: '฿',
      reverseGlobal: '฿'
    },
    text: {
      th: {
        local: {
          other: 'บาท'
        }
      }
    }
  },
  'TRY': {
    symbols: {
      local: '₺',
      global: '₺',
      reverseGlobal: '₺'
    },
    text: {
      tr: {
        local: {
          one: 'lirası',
          other: 'lirası'
        }
      }
    }
  },
  'TWD': {
    symbols: {
      local: 'NT$',
      global: 'NT$',
      reverseGlobal: '$NT'
    },
    text: {
      zh: {
        local: {
          other: '元'
        }
      }
    }
  },
  'TZS': {
    symbols: {
      local: '/=',
      global: 'TSh',
      reverseGlobal: 'ShT'
    },
    text: {
      en: {
        local: {
          one: 'shilingi',
          other: 'shilingi'
        }
      }
    }
  },
  'UAH': {
    symbols: {
      local: '₴',
      global: '₴',
      reverseGlobal: '₴'
    },
    text: {
      ru: {
        local: {
          one: 'гривна',
          many: 'гривен',
          other: 'гривны'
        }
      },
      uk: {
        local: {
          one: 'гривня',
          few: 'гривні',
          many: 'гривень',
          other: 'гривні'
        }
      }
    }
  },
  'USD': {
    symbols: {
      local: '$',
      global: 'US$',
      reverseGlobal: '$US'
    },
    text: {
      en: {
        local: {
          one: 'dollar',
          other: 'dollars'
        }
      }
    }
  },
  'UYU': {
    symbols: {
      local: '$',
      global: 'U$',
      reverseGlobal: '$U'
    },
    text: {
      es: {
        local: {
          one: 'peso',
          other: 'pesos'
        }
      }
    }
  },
  'VND': {
    symbols: {
      local: '₫',
      global: '₫',
      reverseGlobal: '₫'
    },
    text: {
      local: {
        other: 'đồng'
      }
    }
  },
  'YER': {
    symbols: {
      local: 'ر.ي.‏',
      global: 'Rial',
      reverseGlobal: 'Rial'
    },
    text: {
      local: {
        zero: 'ريال',
        one: 'ريال',
        two: 'ريال',
        few: 'ريال',
        many: 'ريال',
        other: 'ريال'
      }
    }
  },
  'ZAR': {
    symbols: {
      local: 'R',
      global: 'R',
      reverseGlobal: 'R'
    },
    text: {
      af: {
        local: {
          one: 'rand',
          other: 'rand'
        }
      },
      en: {
        local: {
          one: 'rand',
          other: 'rand'
        }
      },
      xh: {
        local: {
          one: 'IRandi',
          other: 'IiRandi'
        }
      },
      zu: {
        local: {
          one: 'Rand',
          other: 'Rand'
        }
      }
    }
  }
};
