
module.exports = {
  'arab': {
    '1': '١',
    '2': '٢',
    '3': '٣',
    '4': '٤',
    '5': '٥',
    '6': '٦',
    '7': '٧',
    '8': '٨',
    '9': '٩',
    '0': '٠'
  },
  'arabext': {
    '1': '۱',
    '2': '۲',
    '3': '۳',
    '4': '۴',
    '5': '۵',
    '6': '۶',
    '7': '۷',
    '8': '٨',
    '9': '٩',
    '0': '٠'
  },
  'bali': {
    '1': '\u1b51',
    '2': '\u1b52',
    '3': '\u1b53',
    '4': '\u1b54',
    '5': '\u1b55',
    '6': '\u1b56',
    '7': '\u1b57',
    '8': '\u1b58',
    '9': '\u1b59',
    '0': '\u1b50'
  },
  'beng': {
    '1': '১',
    '2': '২',
    '3': '৩',
    '4': '৪',
    '5': '৫',
    '6': '৬',
    '7': '৭',
    '8': '৮',
    '9': '৯',
    '0': '০'
  },
  'deva': {
    '1': '१',
    '2': '२',
    '3': '३',
    '4': '४',
    '5': '५',
    '6': '६',
    '7': '७',
    '8': '८',
    '9': '९',
    '0': '०'
  },
  'fullwide': {
    '1': '１',
    '2': '２',
    '3': '３',
    '4': '４',
    '5': '５',
    '6': '６',
    '7': '７',
    '8': '８',
    '9': '９',
    '0': '０'
  },
  'gujr': {
    '1': '૧',
    '2': '૨',
    '3': '૩',
    '4': '૪',
    '5': '૫',
    '6': '૬',
    '7': '૭',
    '8': '૮',
    '9': '૯',
    '0': '૦'
  },
  'guru': {
    '1': '੧',
    '2': '੨',
    '3': '੩',
    '4': '੪',
    '5': '੫',
    '6': '੬',
    '7': '੭',
    '8': '੮',
    '9': '੯',
    '0': '੦'
  },
  'hanidec': {
    '1': '一',
    '2': '二',
    '3': '三',
    '4': '四',
    '5': '五',
    '6': '六',
    '7': '七',
    '8': '八',
    '9': '九',
    '0': '〇'
  },
  'khmr': {
    '1': '១',
    '2': '២',
    '3': '៣',
    '4': '៤',
    '5': '៥',
    '6': '៦',
    '7': '៧',
    '8': '៨',
    '9': '៩',
    '0': '០'
  },
  'knda': {
    '1': '೧',
    '2': '೨',
    '3': '೩',
    '4': '೪',
    '5': '೫',
    '6': '೬',
    '7': '೭',
    '8': '೮',
    '9': '೯',
    '0': '೦'
  },
  'laoo': {
    '1': '໑',
    '2': '໒',
    '3': '໓',
    '4': '໔',
    '5': '໕',
    '6': '໖',
    '7': '໗',
    '8': '໘',
    '9': '໙',
    '0': '໐'
  },
  'limb': {
    '1': '\u1946',
    '2': '\u1947',
    '3': '\u1948',
    '4': '\u1949',
    '5': '\u194A',
    '6': '\u194B',
    '7': '\u194C',
    '8': '\u194D',
    '9': '\u194E',
    '0': '\u194F'
  },
  'mlym': {
    '1': '൧',
    '2': '൨',
    '3': '൩',
    '4': '൪',
    '5': '൫',
    '6': '൬',
    '7': '൭',
    '8': '൮',
    '9': '൯',
    '0': '൦'
  },
  'mong': {
    '1': '᠑',
    '2': '᠒',
    '3': '᠓',
    '4': '᠔',
    '5': '᠕',
    '6': '᠖',
    '7': '᠗',
    '8': '᠘',
    '9': '᠙',
    '0': '᠐'
  },
  'mymr': {
    '1': '၁',
    '2': '၂',
    '3': '၃',
    '4': '၄',
    '5': '၅',
    '6': '၆',
    '7': '၇',
    '8': '၈',
    '9': '၉',
    '0': '၀'
  },
  'orya': {
    '1': '୧',
    '2': '୨',
    '3': '୩',
    '4': '୪',
    '5': '୫',
    '6': '୬',
    '7': '୭',
    '8': '୮',
    '9': '୯',
    '0': '୦'
  },
  'tamldec': {
    '1': '௧',
    '2': '௨',
    '3': '௩',
    '4': '௪',
    '5': '௫',
    '6': '௬',
    '7': '௭',
    '8': '௮',
    '9': '௯',
    '0': '௦'
  },
  'telu': {
    '1': '౧',
    '2': '౨',
    '3': '౩',
    '4': '౪',
    '5': '౫',
    '6': '౬',
    '7': '౭',
    '8': '౮',
    '9': '౯',
    '0': '౦'
  },
  'thai': {
    '1': '๑',
    '2': '๒',
    '3': '๓',
    '4': '๔',
    '5': '๕',
    '6': '๖',
    '7': '๗',
    '8': '๘',
    '9': '๙',
    '0': '๐'
  },
  'tibt': {
    '1': '༡',
    '2': '༢',
    '3': '༣',
    '4': '༤',
    '5': '༥',
    '6': '༦',
    '7': '༧',
    '8': '༨',
    '9': '༩',
    '0': '༠'
  }
};
